commit f3c958196478351033ba2ab93d8341af6531f90b
Author: Stefan Schulze Frielinghaus <stefansf@linux.ibm.com>
Date:   Fri Nov 19 16:56:56 2021

    IBM Z: Fix load-and-test peephole2 condition
    
    For a peephole2 condition variable insn points to the first matched
    insn.  In order to refer to the second matched insn use
    peep2_next_insn(1) instead.
    
    gcc/ChangeLog:
    
            * config/s390/s390.md (define_peephole2): Variable insn points
            to the first matched insn.  Use peep2_next_insn(1) to refer to
            the second matched insn.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/s390/20211119.c: New test.
    
    (cherry picked from commit f47870e6a272dfe740a38422030c6c68e0fc7ff8)

diff --git a/gcc/testsuite/gcc.target/s390/20211119.c b/gcc/testsuite/gcc.target/s390/20211119.c
new file mode 100644
index 00000000000..b9d216389f4
--- /dev/null
+++ b/gcc/testsuite/gcc.target/s390/20211119.c
@@ -0,0 +1,12 @@
+/* { dg-do run { target { s390_useable_hw } } } */
+/* { dg-options "-Os -march=z10" } */
+signed char a;
+int b = -925974181, c;
+unsigned *d = &b;
+int *e = &c;
+int main() {
+  *e = ((217 ^ a) > 585) < *d;
+  if (c != 1)
+    __builtin_abort();
+  return 0;
+}

